# norootforbuild

%define desktop_applications mythfrontend mythtv-setup
%define desktop_vendor j0ke

#added cos fedora core must set these macros, and suse doesn' 
%define _varlibdir /var/lib
%define _localstatedir /var
%define _initdir /etc/init.d
%define _logrotatedir /etc/logrotate.d
%define _logdir /var/log 
%define _rundir /var/run 
%define _subsysdir     %{_localstatedir}/lock/subsys
%define compile_type release

%define apiversion %(echo -n %{version} | awk -F. '{print $1 "." $2}')

Summary:   A personal video recorder (PVR) application.
Name:      mythtv
Version:   0.21
Release:   52.19
URL:       http://www.mythtv.org/
License:   GPL2
Group:     Applications/Multimedia
Source0:   http://www.mythtv.org/mc/%{name}-%{version}.tar.bz2
Source1:   sysconfig.mythbackend
Source2:   mythbackend.init.in
Source3:   mythbackend.logrotate.in
Source4:   mythtv.png
Source5:   mythtv.desktop
Source6:   mythfrontend.png
Source7:   mythfrontend.desktop
Source8:   mythtv-setup.png
Source9:   mythtv-setup.desktop
Source10:  mythtv-session.desktop
Source11:  mythfrontend-1024x640.desktop
Source12:  mythfrontend-800x450.desktop
Source13:  mythtv-0.21-svnfixes-binaries.tar.bz2
Source100: mythtv-doc.configure.ac
Source101: mythtv-doc.Makefile.am
Source202: README.non-root
Source203: mythbackend.SuSEfirewall2
Source300: profile.mythtv.sh
Source301: profile.mythtv.csh
Patch0:    mythtv-0.21-svnfixes.patch
Patch1:    mythtv-0.15-ostreaming.patch
Patch4:    mythtv-perl-vendor.patch
Patch5:    mythtv-python-install.patch
Patch6:    mythtv-dbcheck.diff
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gcc-c++
BuildRequires: nasm
BuildRequires: xorg-x11-devel
BuildRequires: freetype2-devel
BuildRequires: libmp3lame-devel
BuildRequires: mysql-devel
BuildRequires: qt3-devel
BuildRequires: alsa-devel
BuildRequires: arts-devel
BuildRequires: dvb
BuildRequires: lirc
%if 0%{?_with_directfb:1}
BuildRequires: DirectFB-devel
%endif
%if 0%{?_with_xvmcnvidia:1}
BuildRequires: nvidia-graphics-devel
%endif
%if 0%{suse_version} <= 1020
BuildRequires: libxine1-xvmc
%else
BuildRequires: libxine1-devel
%endif
%if 0%{suse_version} >= 1100
BuildRequires: libpulse-devel
%endif
BuildRequires: jack
%if 0%{suse_version} > 1000
BuildRequires: Mesa
%else
BuildRequires: xorg-x11-Mesa-devel
%endif
%if 0%{!?_without_firewire:1}
BuildRequires: libavc1394-devel
BuildRequires: libiec61883-devel
BuildRequires: libraw1394-devel
%endif
BuildRequires: libdvdnav-devel
BuildRequires: desktop-file-utils
%if 0%{!?_without_jack:1}
BuildRequires: libjack-devel
%endif
BuildRequires: python-devel 
BuildRequires: perl
%if 0%{?suse_version} > 1020
BuildRequires:  fdupes
%endif

%if 0%{?suse_version} >= 1110
BuildRequires:	update-desktop-files
%endif

%description
MythTV implements the following PVR features, and more, with a
unified graphical interface:

 - Basic 'live-tv' functionality. Pause/Fast Forward/Rewind "live" TV.
 - Video compression using RTjpeg or MPEG-4
 - Program listing retrieval using XMLTV or EPG
 - Themable, semi-transparent on-screen display
 - Electronic program guide
 - Scheduled recording of TV programs
 - Resolution of conflicts between scheduled recordings
 - Basic video editing

%package -n libmyth
# Packmandepends: lame jack
Summary:  Library providing mythTV support.
Group:    System/Libraries
Requires: freetype2 >= 2
Requires: lame
Requires: qt3 >= 3,
Requires: qt3-mysql

%description -n libmyth
Common library code for MythTV and add-on modules (development)
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv-doc package for more information.

%package -n libmyth-devel
Summary:  Development files for libmyth.
Group:    System/Libraries
Requires: libmyth = %{version}
Requires: freetype2-devel >= 2
Requires: lame
Requires: qt3-devel >= 3
Requires: mysql-devel
Requires: alsa-devel
Requires: arts-devel
Requires: lirc
%if 0%{?_with_xvmcnvidia:1}
Requires: nvidia-graphics-devel
%endif
%if 0%{!?_without_xvmcvld:1}
Requires: xorg-x11-devel
%endif
%if 0%{suse_version} <= 1020
%if 0%{!?_without_xvmcw:1}
Requires: libxine1-xvmc
%endif
%else
Requires: libxine1
%endif
%if 0%{?_with_directfb:1}
Requires: DirectFB
%endif
Requires: dvb
Requires: libdvdnav-devel

%description -n libmyth-devel
This package contains the header files and libraries for developing
add-ons for mythTV.

%package doc
Summary:   Mythtv documentation files and contributions
Group:     Applications/Multimedia    
Obsoletes: mythtv

%description doc
MythTV implements the following PVR features, and more, with a
unified graphical interface:

 - Basic 'live-tv' functionality. Pause/Fast Forward/Rewind "live" TV.
 - Video compression using RTjpeg or MPEG-4
 - Program listing retrieval using XMLTV or EPG
 - Themable, semi-transparent on-screen display
 - Electronic program guide
 - Scheduled recording of TV programs
 - Resolution of conflicts between scheduled recordings
 - Basic video editing

%package themes
Summary: Base themes for mythTV's frontend.
Group:   Applications/Multimedia

%description themes
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv-doc package for more information.

This package contains only the base themes used by the frontend and
mythtv setup.

%package frontend
Summary:  Client component of mythTV (a PVR).
Group:    Applications/Multimedia
Requires: mythtv-themes = %{version}
Provides: mythtv-frontend-api = %{apiversion}

%description frontend
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv-doc package for more information.

This package contains only the client software, which provides a
front-end for playback and configuration.  It requires access to a
mythtv-backend installation, either on the same system or one
reachable via the network.

%package backend
Summary:   Server component of mythTV (a PVR).
Group:     Applications/Multimedia
Conflicts: xmltv-grabbers < 0.5.34
PreReq:    %fillup_prereq
Requires:  mythtv-transcode

%description backend
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv-doc package for more information.

This package contains only the server software, which provides video
and audio capture and encoding services.  In order to be useful, it
requires a mythtv-frontend installation, either on the same system or
one reachable via the network.

%package transcode
Summary:   mythTV transcode and replex utilities
Group:     Applications/Multimedia

%description transcode
Mythtvs utility programs for transcoding and replexing.

%package setup
Summary:   Setup the mythTV backend.
Group:     Applications/Multimedia
Requires:  mythtv-backend = %{version}
Requires:  mythtv-themes = %{version}

%description setup
MythTV provides a unified graphical interface for recording and viewing
television programs.  Refer to the mythtv-doc package for more information.

This package contains only the setup software for configuring the
mythTV backend.

%package -n perl-MythTV
Summary:   Perl bindings for mythtv
Group:     Development/Libraries/Perl
Requires:  perl = %{perl_version}
Requires:  perl-DBI
Requires:  perl-DBD-mysql
Requires:  perl-libwww-perl
Provides:  perl-mythtv
Obsoletes: perl-mythtv < 0.21

%description -n perl-MythTV
This package contains the perl bindings for MythTV

%package -n python-MythTV
Summary:   Python bindings for mythtv
Group:     Development/Libraries/Python
%py_requires

%description -n python-MythTV
This package contains the python bindings for MythTV


%if 0%{suse_version} >= 930
%debug_package
%endif

%prep
%setup -q -a 13
%patch0 -p1
%patch1 -p0
%patch4 -p1
%patch5 -p1
%patch6 -p1

echo "QMAKE_PROJECT_DEPTH = 0" >> mythtv.pro
echo "QMAKE_PROJECT_DEPTH = 0" >> settings.pro

cp -a %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE202} . #  cp -a %{SOURCE200} %{SOURCE201} .
for file in \
            mythbackend.init \
            mythbackend.logrotate; do
  sed -e's|@logdir@|%{_logdir}|g' \
      -e's|@rundir@|%{_rundir}|g' \
      -e's|@initdir@|%{_initdir}|g' \
      -e's|@bindir@|%{_bindir}|g' \
      -e's|@sbindir@|%{_sbindir}|g' \
      -e's|@subsysdir@|%{_subsysdir}|g' \
      -e's|@varlibdir@|%{_varlibdir}|g' \
      -e's|@logrotatedir@|%{_logrotatedir}|g' \
  < $file.in > $file
done

%build
export QTDIR=/usr/lib/qt3
export PATH=$QTDIR/bin:$PATH
./configure \
	--compile-type=release \
%ifarch i586 i686
	--arch=i586 --tune=i686 \
	--enable-mmx \
%endif
%ifarch x86_64
	--arch=x86_64 \
	--enable-mmx \
%endif
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libdir-name=%{_lib} \
	--with-bindings=perl,python \
	--enable-joystick-menu \
	--enable-lirc \
	--enable-ivtv \
	%{!?_without_firewire:--enable-firewire}%{?_without_firewire:--disable-firewire} \
	--enable-dvb \
        --dvb-path=/usr/include \
	--enable-audio-oss --enable-audio-alsa --enable-audio-arts \
%if 0%{suse_version} >= 1100
	--enable-audio-pulse \
%endif
	%{!?_without_jack:--enable-audio-jack} \
	%{?_without_jack:--disable-audio-jack} \
	--enable-x11 \
	%{!?_without_xrandr:--enable-xrandr} \
	%{?_without_xrandr:--disable-xrandr} \
	--enable-xv \
	%{?!_without_xvmcnvidia:--enable-xvmc} \
	--enable-xvmc \
        %{?_without_xvmcnvidia:%{?_without_xvmcw:--disable-xvmc}} \
	%{!?_without_xvmcvld:--enable-xvmc-vld --enable-xvmc-pro} \
	%{?_without_xvmcvld:--disable-xvmc-vld --disable-xvmc-pro} \
	--enable-opengl-vsync \
	--enable-opengl-video \
	%{?_with_directfb:--enable-directfb}%{!?_with_directfb:--disable-directfb}

perl -pi -e"s|^OPTFLAGS=.*|OPTFLAGS=%{optflags} -fomit-frame-pointer|" config.mak
perl -pi -e's|^ARCHFLAGS=.*|ARCHFLAGS=|' config.mak

qmake mythtv.pro
make

find contrib -type f | xargs -r chmod a-x 

%install
rm -rf %{buildroot}

make install INSTALL_ROOT=%{buildroot}

ln -s mythtv-setup %{buildroot}%{_bindir}/mythtvsetup
install -d %{buildroot}%{_varlibdir}/mythtv
install -d %{buildroot}%{_logdir}/mythtv
install -d %{buildroot}/usr/share/doc/packages/mythtv
install -d %{buildroot}/usr/sbin

install -D mythbackend.init %{buildroot}%{_initdir}/mythbackend
install -m 644 -D sysconfig.mythbackend %{buildroot}/var/adm/fillup-templates/sysconfig.mythbackend
install -m 644 -D mythbackend.logrotate  %{buildroot}%{_logrotatedir}/mythbackend
ln -sf ../../etc/init.d/mythbackend %{buildroot}/usr/sbin/rcmythbackend
install -m 644 -D %{SOURCE203} %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/mythbackend
#install %{SOURCE201} %{buildroot}/usr/share/doc/packages/mythtv
pushd programs
  for subdir in *; do
    if test -e $subdir/README; then
      cp $subdir/README ../README.$subdir
    fi
  done
popd

# Desktop entries
install -m 644 -D %{_sourcedir}/mythtv.png %{buildroot}%{_datadir}/pixmaps/mythtv.png
install -m 644 -D %{_sourcedir}/mythfrontend.png %{buildroot}%{_datadir}/pixmaps/mythfrontend.png
install -m 644 -D %{_sourcedir}/mythtv-setup.png %{buildroot}%{_datadir}/pixmaps/mythtv-setup.png

%if 0%{?suse_version} >= 1110
%suse_update_desktop_file mythtv
%suse_update_desktop_file mythfrontend
%suse_update_desktop_file mythfrontend-1024x640
%suse_update_desktop_file mythfrontend-800x450
%suse_update_desktop_file mythtv-setup
%endif

install -m 644 -D %{_sourcedir}/mythtv.desktop %{buildroot}%{_datadir}/applications/mythtv.desktop
install -m 644 -D %{_sourcedir}/mythfrontend.desktop %{buildroot}%{_datadir}/applications/mythfrontend.desktop
install -m 644 -D %{_sourcedir}/mythfrontend-1024x640.desktop %{buildroot}%{_datadir}/applications/mythfrontend-1024x640.desktop
install -m 644 -D %{_sourcedir}/mythfrontend-800x450.desktop %{buildroot}%{_datadir}/applications/mythfrontend-800x450.desktop
install -m 644 -D %{_sourcedir}/mythtv-setup.desktop %{buildroot}%{_datadir}/applications/mythtv-setup.desktop

install -m 644 -D %{_sourcedir}/mythtv-session.desktop %{buildroot}%{_datadir}/xsessions/mythtv.desktop

mkdir -p %{buildroot}%{_libdir}/mythtv/plugins
mkdir -p %{buildroot}%{_datadir}/mythtv/build/

install -p settings.pro %{buildroot}%{_datadir}/mythtv/build/

install -d %{buildroot}%{_docdir}/%{name}-doc
cp -r docs/*.html docs/*.png %{buildroot}%{_docdir}/%{name}-doc
cp -r README* UPGRADING AUTHORS COPYING FAQ keys.txt %{buildroot}%{_docdir}/%{name}-doc
cp -r database %{buildroot}%{_docdir}/%{name}-doc
cp -r contrib %{buildroot}%{_docdir}/%{name}-doc

%if 0%{suse_version} >= 1100
install -d %{buildroot}%{_sysconfdir}/profile.d
install -m 644 %{S:300} %{buildroot}%{_sysconfdir}/profile.d/mythtv.sh
install -m 644 %{S:301} %{buildroot}%{_sysconfdir}/profile.d/mythtv.csh
%endif

%if 0%{?suse_version} > 1020
%fdupes $RPM_BUILD_ROOT%{_datadir}/mythtv
%fdupes $RPM_BUILD_ROOT%{_docdir}/mythtv-doc
%endif

%perl_process_packlist

%clean
echo ==============================
echo rm -rf %{buildroot}
echo ==============================

%post -n libmyth -p /sbin/ldconfig

%postun -n libmyth -p /sbin/ldconfig

%post backend
%fillup_only -n mythbackend

%preun backend
%stop_on_removal mythbackend

%postun backend
%restart_on_update mythbackend
%insserv_cleanup

%files doc
%defattr(-,root,root,-)
%{_docdir}/mythtv-doc/*

%define ghostattr %attr(0644,root,root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace)

%files backend
%defattr(-,root,root,-)
#config(noreplace) %{_datadir}/mythtv/mysql.txt
%{_bindir}/mythbackend
%{_bindir}/mythfilldatabase
%{_bindir}/mythjobqueue
%dir %{_varlibdir}/mythtv
%{_initdir}/mythbackend
/usr/sbin/rcmythbackend
/var/adm/fillup-templates/sysconfig.mythbackend
%config %{_logrotatedir}/mythbackend
%dir %{_logdir}/mythtv
%doc README.non-root
%config(noreplace) %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/mythbackend

# Hm, somehow this doesn't work yet ... :(
#%ghostattr %{_logdir}/mythtv/mythbackend.log*
#%ghostattr %{_rundir}/mythbackend.pid
#%ghostattr %{_subsysdir}/mythbackend

%files transcode
%defattr(-,root,root,-)
%{_bindir}/mythtranscode
%{_bindir}/mythreplex

%files setup
%defattr(-,root,root,-)
%{_bindir}/mythtv-setup
%{_bindir}/mythtvsetup
%{_datadir}/mythtv/setup.xml
%{_datadir}/applications/mythtv-setup.desktop
%{_datadir}/pixmaps/mythtv-setup.png

%files frontend
%defattr(-,root,root,-)
#config(noreplace) %{_datadir}/mythtv/mysql.txt
%{_datadir}/mythtv/info_menu.xml
%{_datadir}/mythtv/info_settings.xml
%{_datadir}/mythtv/library.xml
%{_datadir}/mythtv/main_settings.xml
%{_datadir}/mythtv/mainmenu.xml
%{_datadir}/mythtv/manage_recordings.xml
%{_datadir}/mythtv/media_settings.xml
%{_datadir}/mythtv/optical_menu.xml
%{_datadir}/mythtv/recpriorities_settings.xml
%{_datadir}/mythtv/tv_lists.xml
%{_datadir}/mythtv/tv_schedule.xml
%{_datadir}/mythtv/tv_search.xml
%{_datadir}/mythtv/tv_settings.xml
%{_datadir}/mythtv/tvmenu.xml
%{_datadir}/mythtv/util_menu.xml
%{_bindir}/mythfrontend
%{_bindir}/mythtv
%{_bindir}/mythcommflag
%{_bindir}/mythtvosd
%{_bindir}/mythlcdserver
%{_bindir}/mythshutdown
%{_bindir}/mythwelcome
%{_libdir}/mythtv/filters
%{_libdir}/mythtv/plugins
%{_datadir}/mythtv/*.ttf
%{_datadir}/mythtv/i18n
%{_datadir}/xsessions/mythtv.desktop
%{_datadir}/applications/mythfrontend.desktop
%{_datadir}/applications/mythfrontend-1024x640.desktop
%{_datadir}/applications/mythfrontend-800x450.desktop
%{_datadir}/applications/mythtv.desktop
%{_datadir}/pixmaps/mythfrontend.png
%{_datadir}/pixmaps/mythtv.png
%if 0%{suse_version} >= 1100
%config %{_sysconfdir}/profile.d/*
%endif

%files themes
%defattr(-,root,root,-)
%{_datadir}/mythtv/themes

%files -n libmyth
%defattr(-,root,root,-)
%{_libdir}/*.so.*
%{_datadir}/mythtv/CDS_scpd.xml
%{_datadir}/mythtv/CMGR_scpd.xml
%{_datadir}/mythtv/MSRR_scpd.xml
%{_datadir}/mythtv/MXML_scpd.xml
%{_datadir}/mythtv/devicemaster.xml
%{_datadir}/mythtv/deviceslave.xml


%files -n libmyth-devel
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.a
%{_datadir}/mythtv/build/settings.pro

%files -n perl-MythTV
%defattr(-,root,root,-)
%{perl_vendorlib}/IO/Socket/INET/MythTV.pm
%{perl_vendorlib}/MythTV.pm
%{perl_vendorlib}/MythTV
%{perl_vendorarch}/auto/MythTV

%files -n python-MythTV
%defattr(-,root,root,-)
%if %{suse_version} >= 1020
%{py_sitedir}/MythTV-0.21-py%{py_ver}.egg-info
%endif
%{py_sitedir}/MythTV

%changelog
* Thu Aug 21 2008 Carsten Schoene <cs@linux-administrator.com>
- initial SLE_10 import
